(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("bootstrap"));
	else if(typeof define === 'function' && define.amd)
		define(["bootstrap"], factory);
	else if(typeof exports === 'object')
		exports["carbon-bootstrap"] = factory(require("bootstrap"));
	else
		root["CarbonBootstrap"] = factory(root["bootstrap"]);
})(typeof self !== 'undefined' ? self : this, function(__WEBPACK_EXTERNAL_MODULE_0__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_0__;

/***/ }),
/* 1 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_bootstrap__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_bootstrap___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_bootstrap__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__layout__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__collapse_sidebar__ = __webpack_require__(3);
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "CollapseSidebar", function() { return __WEBPACK_IMPORTED_MODULE_2__collapse_sidebar__["a"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "Layout", function() { return __WEBPACK_IMPORTED_MODULE_1__layout__["a"]; });






/***/ }),
/* 2 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_bootstrap__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_bootstrap___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_bootstrap__);
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
// @ts-ignore

var NAME = 'layout';
var DATA_KEY = 'ca.bs.layout';
var EVENT_KEY = "." + DATA_KEY;
var DATA_API_KEY = '.data-api';
var JQUERY_NO_CONFLICT = $.fn[NAME];
var TRANSITION_DURATION = 250;
var ClassNames = {
    SHOW: 'show',
    COLLAPSE: 'collapse',
    COLLAPSING: 'collapsing',
    COLLAPSED: 'collapsed',
};
var Default = {
    root: '.ca-root',
    mode: 'toggle',
    durationCssElement: '.ca-sidebar',
};
var Event = {
    SHOW: "show" + EVENT_KEY,
    SHOWN: "shown" + EVENT_KEY,
    HIDE: "hide" + EVENT_KEY,
    HIDDEN: "hidden" + EVENT_KEY,
    CLICK_DATA_API: "click" + EVENT_KEY + DATA_API_KEY,
};
var Selector = {
    DATA_LAYOUT: '[data-layout]',
};
var Layout = /** @class */ (function () {
    function Layout(element, config) {
        this._$element = $(element);
        this._$root = $(config.root);
        this._config = config;
    }
    Object.defineProperty(Layout.prototype, "elementType", {
        get: function () {
            return this._config.layout || '';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Layout.prototype, "mode", {
        get: function () {
            return this._config.mode || '';
        },
        enumerable: true,
        configurable: true
    });
    Layout.prototype.toggle = function () {
        if (this._$root.hasClass(this.elementType + "-" + ClassNames.SHOW)) {
            this.hide();
        }
        else {
            this.show();
        }
    };
    Layout.prototype.show = function () {
        var _this = this;
        var collapse = this.elementType + "-" + ClassNames.COLLAPSE;
        var collapsing = this.elementType + "-" + ClassNames.COLLAPSING;
        var show = this.elementType + "-" + ClassNames.SHOW;
        if (this._getTransitioning() || this._$root.hasClass(show)) {
            return;
        }
        var startEvent = $.Event(Event.SHOW, { layout: this.elementType });
        this._$root.trigger(startEvent);
        if (startEvent.isDefaultPrevented()) {
            return;
        }
        this._$root
            .removeClass(collapse)
            .addClass(collapsing)
            .addClass(show);
        this._setTransitioning(true);
        var complete = function () {
            _this._$root.removeClass(collapsing).addClass(collapse);
            _this._setTransitioning(false);
            _this._$root.trigger(Event.SHOWN, { layout: _this.elementType });
        };
        if (!__WEBPACK_IMPORTED_MODULE_0_bootstrap__["Util"].supportsTransitionEnd()) {
            complete();
            return;
        }
        this._$root.one(__WEBPACK_IMPORTED_MODULE_0_bootstrap__["Util"].TRANSITION_END, complete).emulateTransitionEnd(this._getCalculatedTransitionDuration());
    };
    Layout.prototype.hide = function () {
        var _this = this;
        var collapse = this.elementType + "-" + ClassNames.COLLAPSE;
        var collapsing = this.elementType + "-" + ClassNames.COLLAPSING;
        var show = this.elementType + "-" + ClassNames.SHOW;
        if (this._getTransitioning() || !this._$root.hasClass(show)) {
            return;
        }
        var startEvent = $.Event(Event.HIDE, { layout: this.elementType });
        this._$root.trigger(startEvent);
        if (startEvent.isDefaultPrevented()) {
            return;
        }
        this._$root
            .addClass(collapsing)
            .removeClass(collapse)
            .removeClass(show);
        this._setTransitioning(true);
        var complete = function () {
            _this._setTransitioning(false);
            _this._$root
                .removeClass(collapsing)
                .addClass(collapse)
                .trigger(Event.HIDDEN, { layout: _this.elementType });
        };
        this._$root.one(__WEBPACK_IMPORTED_MODULE_0_bootstrap__["Util"].TRANSITION_END, complete).emulateTransitionEnd(this._getCalculatedTransitionDuration());
    };
    Layout.prototype._getTransitioning = function () {
        var transitioning = this._$root.data('ca.transitioning');
        if (typeof transitioning === 'undefined') {
            transitioning = {};
        }
        if (typeof transitioning[this.elementType] === 'undefined') {
            transitioning[this.elementType] = false;
        }
        this._$root.data('ca.transitioning', transitioning);
        return transitioning[this.elementType];
    };
    Layout.prototype._setTransitioning = function (val) {
        var transitioning = this._$root.data('ca.transitioning');
        if (typeof transitioning === 'undefined') {
            transitioning = {};
        }
        transitioning[this.elementType] = val;
        this._$root.data('ca.transitioning', transitioning);
    };
    Layout.prototype._getElementTypeKey = function () {
        var match = /\[data-(\w+)\]/gi.exec(Selector.DATA_LAYOUT);
        return match ? match[1] : '';
    };
    Layout.prototype._getCalculatedTransitionDuration = function () {
        if (this._resolvedDuration)
            return this._resolvedDuration;
        if (this._config.durationCssElement) {
            var target = document.querySelector(this._config.durationCssElement);
            if (target) {
                var computed = getComputedStyle(target);
                var duration = computed['transitionDuration'];
                if (duration) {
                    var isMillisecond = duration.indexOf('ms') >= 0;
                    var match = duration.match(/\d+(\.\d+)?/g);
                    if (match) {
                        var numbers = parseFloat(match[0]);
                        this._resolvedDuration = Math.ceil(isMillisecond ? numbers : numbers * 1000);
                        return this._resolvedDuration;
                    }
                }
            }
        }
        this._resolvedDuration = TRANSITION_DURATION;
        return this._resolvedDuration;
    };
    // tslint:disable-next-line:naming-convention
    Layout._jQueryInterface = function (config) {
        var $this = $(this);
        var method = config;
        var data = $this.data(DATA_KEY);
        if (!data) {
            var cfg = __assign({}, Default, (typeof config === 'object' && config));
            cfg.layout = $this.data('layout');
            data = new Layout(this, cfg);
            $this.data(DATA_KEY, data);
            method = data.mode;
        }
        if (typeof method === 'string') {
            if (typeof data[method] === 'undefined') {
                throw new Error("No method named \"" + method + "\"");
            }
            data[method]();
        }
    };
    return Layout;
}());
/* harmony default export */ __webpack_exports__["a"] = (Layout);
$(document).on(Event.CLICK_DATA_API, Selector.DATA_LAYOUT, function (event) {
    if (event.currentTarget.tagName === 'A') {
        event.preventDefault();
    }
    var $trigger = $(event.currentTarget);
    var data = $trigger.data(DATA_KEY);
    var config = data ? data.mode : $trigger.data();
    Layout._jQueryInterface.call($trigger[0], config);
});
$.fn[NAME] = Layout._jQueryInterface;
$.fn[NAME].Constructor = Layout;
$.fn[NAME].noConflict = function () {
    $.fn[NAME] = JQUERY_NO_CONFLICT;
    return Layout._jQueryInterface;
};


/***/ }),
/* 3 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var NAME = 'sidemenu';
var DATA_KEY = 'ca.bs.collapse.sidemenu';
var EVENT_KEY = "." + DATA_KEY;
var DATA_API_KEY = '.data-api';
var JQUERY_NO_CONFLICT = $.fn[NAME];
var Default = {
    root: '.ca-root',
};
var ClassNames = {
    SHOW: 'show',
    ROOT_SHOW: 'sidebar-show',
};
var Event = {
    CLICK_DATA_API: "click" + EVENT_KEY + DATA_API_KEY,
    SHOW: "show" + EVENT_KEY,
    HIDE: "hide" + EVENT_KEY,
};
var Selector = {
    DATA_TOGGLE: '[data-toggle="sidemenu"]',
};
var CollapseSidebar = /** @class */ (function () {
    function CollapseSidebar(element, config) {
        var _this = this;
        this._hideHandler = this._onHide.bind(this);
        this._$element = $(element);
        this._$target = $(this._$element.attr('href'));
        this._$root = $(config.root);
        this._config = config;
        this._$target
            .collapse({ toggle: false })
            .on('show.bs.collapse', function () {
            _this._$element.attr('aria-expanded', 'true');
            _this._$element.trigger(Event.SHOW);
        })
            .on('hide.bs.collapse', function () {
            _this._$element.attr('aria-expanded', 'false');
            _this._$element.trigger(Event.HIDE);
        });
        if (this._config.auto) {
            this._$root.on('hide.ca.bs.layout', this._hideHandler);
        }
    }
    CollapseSidebar.prototype.toggle = function () {
        if (this._$root.hasClass(ClassNames.ROOT_SHOW)) {
            this._$target.collapse('toggle');
        }
    };
    CollapseSidebar.prototype._onHide = function (ev) {
        if (ev['layout'] === 'sidebar') {
            this._$target.collapse('hide');
        }
    };
    // tslint:disable-next-line:naming-convention
    CollapseSidebar._jQueryInterface = function (config) {
        var $this = $(this);
        var data = $this.data(DATA_KEY);
        if (!data) {
            var cfg = __assign({}, Default, (typeof config === 'object' && config));
            data = new CollapseSidebar(this, cfg);
            $this.data(DATA_KEY, data);
        }
        data.toggle();
    };
    return CollapseSidebar;
}());
/* harmony default export */ __webpack_exports__["a"] = (CollapseSidebar);
$(document).on(Event.CLICK_DATA_API, Selector.DATA_TOGGLE, function (event) {
    if (event.currentTarget.tagName === 'A') {
        event.preventDefault();
    }
    var $trigger = $(event.currentTarget);
    var data = $trigger.data(DATA_KEY);
    var config = data ? 'toggle' : $trigger.data();
    CollapseSidebar._jQueryInterface.call($trigger[0], config);
});
$.fn[NAME] = CollapseSidebar._jQueryInterface;
$.fn[NAME].Constructor = CollapseSidebar;
$.fn[NAME].noConflict = function () {
    $.fn[NAME] = JQUERY_NO_CONFLICT;
    return CollapseSidebar._jQueryInterface;
};


/***/ })
/******/ ]);
});